/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_AorticValveFindingSites;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_AorticValveFindingSites;
import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;

/**
 * This class represents AorticValveFindingSites CID12242
 */
public class AorticValveFindingSites_CID12242 {

	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * Instantiates a new AorticValveFindingSites_CID12242 Template 
	 */
	public AorticValveFindingSites_CID12242()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumAorticValveFindingSites Object of EnumCM_AorticValveFindingSites represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_AorticValveFindingSites enumAorticValveFindingSites)
	{
		switch(enumAorticValveFindingSites)
		{
		case AORTIC_VALVE_RING: this.strCodeValue =EnumCV_AorticValveFindingSites.AORTIC_VALVE_RING_T_35410.getValue(); break;
		}
	}

	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumAorticValveFindingSites Object of EnumCM_AorticValveFindingSites represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_AorticValveFindingSites enumAorticValveFindingSites)
	{
		switch(enumAorticValveFindingSites)
		{
		case AORTIC_VALVE_RING : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.AORTIC_VALVE_RING.getSNOMEDCTID(); break;
		}
	}

	/**
	 * Sets the value for AorticValveFindingSites
	 * @param enumAorticValveFindingSites Object of EnumCM_AorticValveFindingSites.
	 */
	public void setAorticValveFindingSites(EnumCM_AorticValveFindingSites enumAorticValveFindingSites)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumAorticValveFindingSites.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumAorticValveFindingSites);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumAorticValveFindingSites);
	}
}
